{ this is nothing fancy, but it tests all event handlers, and most of the major
  run-time properties that wuld be used.
}
unit Tbtest01;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Thtabs, Rotatel;

type
  TForm1 = class(TForm)
    Notebook1: TNotebook;
    ListBox1: TListBox;
    Label1: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Edit1: TEdit;
    Label3: TLabel;
    Button7: TButton;
    ThTabSet1: TThTabSet;
    Label2: TLabel;
    FontDialog1: TFontDialog;
    Button8: TButton;
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure ThTabSet1Click(Sender: TObject);
    procedure ThTabSet1Enter(Sender: TObject);
    procedure ThTabSet1Exit(Sender: TObject);
    procedure ThTabSet1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ThTabSet1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ThTabSet1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ThTabSet1KeyPress(Sender: TObject; var Key: Char);
    procedure ThTabSet1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ThTabSet1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ThTabSet1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ThTabSet1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ThTabSet1EndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure Button7Click(Sender: TObject);
    procedure ThTabSet1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure Button8Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button4Click(Sender: TObject);
begin
  case (Sender as TButton).Tag of
    0 : ThTabSet1.Orientation := toLeft;
    1 : ThTabSet1.Orientation := toRight;
    2 : ThTabSet1.Orientation := toTop;
    3 : ThTabSet1.Orientation := toBottom;
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  if ThTabSet1.Notebook = nil then
    ThTabSet1.Notebook := Notebook1
  else
    ThtabSet1.Notebook := nil;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  ThTabSet1.NotebookColor := not ThTabSet1.NotebookColor;
  if not ThTabSet1.NotebookColor then ThTabSet1.SelectedColor := clTeal;
end;

procedure TForm1.ThTabSet1Click(Sender: TObject);
begin
  Listbox1.Items.Add('Click Event : ' + Notebook1.Pages[Notebook1.PageIndex]);
end;

procedure TForm1.ThTabSet1Enter(Sender: TObject);
begin
  ListBox1.Items.Add('Enter tabset');
end;

procedure TForm1.ThTabSet1Exit(Sender: TObject);
begin
  Listbox1.Items.Add('Exit Tabset');
end;

procedure TForm1.ThTabSet1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Label1.Caption := Format('Mouse move : %d,%d',[X,Y]);
end;

procedure TForm1.ThTabSet1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ListBox1.Items.Add(Format('Mouse Down %d,%d',[X,Y]));
end;

procedure TForm1.ThTabSet1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ListBox1.Items.Add(Format('Mouse Up %d,%d',[X,Y]));
end;

procedure TForm1.ThTabSet1KeyPress(Sender: TObject; var Key: Char);
begin
  ListBox1.Items.Add('Keypress Event');
  Label2.Caption := Label2.Caption + Key;
end;

procedure TForm1.ThTabSet1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  ListBox1.Items.Add(Format('Key Down %d',[Key]));
end;

procedure TForm1.ThTabSet1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  ListBox1.Items.Add(Format('Key Up %d',[Key]));
end;

procedure TForm1.ThTabSet1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  if Source is Tedit then
    Accept := TRUE
  else
    Accept := FALSE;
end;

procedure TForm1.ThTabSet1DragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  if Source is Tedit then
  begin
    Notebook1.Pages[0] := (Source as Tedit).Text;
    ThTabSet1.Notebook := nil;
    ThTabSet1.Notebook := Notebook1;
  end;
end;

procedure TForm1.ThTabSet1EndDrag(Sender, Target: TObject; X, Y: Integer);
begin
  ListBox1.Items.Add('End Drag Event');
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  ThTabSet1.ShowHint := not ThTabSet1.ShowHint;
end;

procedure TForm1.ThTabSet1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
  ListBox1.Items.Add('Change Event');
  if NewTab = 2 then AllowChange := FALSE else AllowChange := TRUE;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  FontDialog1.Font := ThTabSet1.Font;
  if FontDialog1.Execute then ThTabSet1.Font := FOntDialog1.Font;
end;

end.
